| IGLib 1.6.0 The IGLib base library for development of numerical, technical and business applications.

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Events
Public Member Functions | Public Attributes | Protected Member Functions | List of all members
IG.Num.NeuralTrainingParametersDto Class Reference

Transfer Object (DTO) for neural network training set. More...

Inheritance diagram for IG.Num.NeuralTrainingParametersDto:
[legend]
Collaboration diagram for IG.Num.NeuralTrainingParametersDto:
[legend]

## Public Member Functions
override NeuralTrainingParameters | CreateObject ()
| Creates and returns a new object of the corresponding type. More...

## Public Attributes
double | LearningRate
| Learning rate. More...
double | Momentum
| Momentum. Specifies how much changes of weight in the previous iterations affect changes in the current iterations. More...
double | SigmoidAlphaValue
| Sigmoid alpha value (used in networks with sigmoid activation functions). More...
int | InputLength
| Gets or sets the number of input neurons. More...
int | OutputLength
| Gets or sets the number of output neurons. More...
double | InputBoundSafetyFactor
double | OutputBoundSafetyFactor
int | MaxEpochs
| Maximal number of epochs performed in the training procedure. More...
int | EpochsInBundle
| Number of epochs in bundle (i.e. number of epochs performed at once, without any checks or output operations between). More...
VectorDtoBase | InputRange
| Range from actual inputs. More...
VectorDtoBase | OutputRange
| Range from actual outputs. More...
VectorDtoBase | ToleranceRms
| Tolerance over RMS error of outputs over training points. Training will continue until error becomes below tolerance or until maximal number of epochs is reached. If less or equal than 0 then this tolerance is not taken into account. More...
VectorDtoBase | ToleranceRmsRelativeToRange
| Relative tolerances on RMS errors of outputs over training points, relative to the correspoinding ranges of output data. More...
double | ToleranceRmsRelativeToRangeScalar = NeuralTrainingParameters.DefaultToleranceRmsRelativeToRangeScalar
| Scalar through which all components of the Relative tolerances on RMS errors of outputs can be set to the same value. More...
VectorDtoBase | ToleranceMax
| Tolerance on maximal error of outputs over training points. Training will continue until error becomes below tolerance or until maximal number of epochs is reached. If less or equal than 0 then this tolerance is not taken into account. More...
VectorDtoBase | ToleranceMaxRelativeToRange
| Relative tolerances on max. abs. errors of outputs over training points, relative to the correspoinding ranges of output data. More...
double | ToleranceMaxRelativeToRangeScalar = NeuralTrainingParameters.DefaultToleranceMaxRelativeToRangeScalar
| Scalar through which all components of the Relative tolerances on max. abs. errors of outputs can be set to the same value. More...
int | NumHiddenLayers
| Number of Hideden layers. More...
int[] | NumHidenNeurons
| Numbers of neurons in each hidden layer. More...
bool | IsNetworkTrained
| Whether the network is trained (and results exist). More...
VectorDtoBase | ErrorsTrainingRms
| RMS errors calculated on training data. More...
VectorDtoBase[] | ErrorsTrainingRmsTable
| Convergence Table of RMS errors calculated on training data. More...
VectorDtoBase | ErrorsTrainingMax
| Maximal errors calculated on training data. More...
VectorDtoBase[] | ErrorsTrainingMaxTable
| Convergence Table of Maximal errors calculated on training data. More...
VectorDtoBase | ErrorsTrainingMeanAbs
| Mean absolute errors calculated on training data. More...
VectorDtoBase | ErrorsVerificationRms
| RMS errors calculated on verification data. More...
VectorDtoBase[] | ErrorsVerificationRmsTable
| Convergence Table of RMS errors calculated on verification data. More...
VectorDtoBase | ErrorsVerificationMax
| Maximal errors calculated on verification data. More...
VectorDtoBase[] | ErrorsVerificationMaxTable
| Convergence Table of Maximal errors calculated on verification data. More...
VectorDtoBase | ErrorsVerificationMeanAbs
| Maximal errors calculated on training data. More...
List< VectorDtoBase > | ErrorsRmsList
int | NumEpochs
| Number of epochs actually spent at training. More...
double | TrainingTime
| Time spent for training. More...
double | TrainingCpuTime
| CPU time spent for training. More...
int[] | EpochNumbers
| List of epoch numbers at which convergence data was sampled. More...
double[] | EpochErrorsRms
| List of sampled RMS errors corresponding to epoch numbers from EpochNumbers. More...
double[] | EpochErrorsAbs
| List of sampled absolute errors corresponding to epoch numbers from EpochNumbers. More...

## Protected Member Functions
override void | CopyFromPlain (NeuralTrainingParameters trainingParameters)
| Copies the specified training parameters to the current DTO. More...
override void | CopyToPlain (ref NeuralTrainingParameters trainingParameters)
| Copies contents of the current DTO to the specified training parameters object. More...
Protected Member Functions inherited from IG.Lib.SerializationDto< NeuralTrainingParameters >
| SerializationDto ()

## Additional Inherited Members
Static Public Member Functions inherited from IG.Lib.SerializationDto< NeuralTrainingParameters >
static ObjectType | CopyToObjectReturned< DtoType, ObjectType > (DtoType dto, ObjectType obj)
| Replacement for CopyToObject<DtoType> for cases where object can not be passed by reference. The returned object must be assigned to object (property, list element, etc.) to which object state is copied. More...
static void | CopyToObject< DtoType, ObjectType > (DtoType dto, ref ObjectType obj)
| Copies object state form the specified DTO (data transfer object) to the specified object. More...
static DtoType | CopyFromObjectReturned< DtoType, ObjectType > (ObjectType obj, DtoType dto)
| Replacement for CopyObjectFromObject<DtoType> for cases where object can not be passed by reference. The returned object must be assigned to object (property, list element, etc.) to which object state is copied. More...
static void | CopyFromObject< DtoType, ObjectType > (ObjectType obj, ref DtoType dto)
| Copies object state form the specified object to the corresponding DTO (data transfer object). More...
static ObjectType[] | CopyArrayToObjectReturned< DtoType, ObjectType > (DtoType[] tabDto, ObjectType[] tabObj)
| Replacement for CopyArrayToObject for cases where object can not be passed by reference. The returned object must be assigned to object (property, list element, etc.) to which data is copied. More...
static void | CopyArrayToObject< DtoType, ObjectType > (DtoType[] tabDto, ref ObjectType[] tabObj)
| Copies array of DTOs (Data Transfer Objects) to an array of appropriate objects. More...
static DtoType[] | CopyArrayFromObjectReturned< DtoType, ObjectType > (ObjectType[] tabObj, DtoType[] tabDto)
| Replacement for CopyArrayFromObject for cases where object can not be passed by reference. The returned object must be assigned to object (property, list element, etc.) to which data is copied. More...
static void | CopyArrayFromObject< DtoType, ObjectType > (ObjectType[] tabObj, ref DtoType[] tabDto)
| Copies array of objects to an array of DTOs. More...
static List< ObjectType > | CopyListToObjectReturned< DtoType, ObjectType > (DtoType[] tabDto, List< ObjectType > listObj)
| Replacement for CopyListToObject for cases where object can not be passed by reference. The returned object must be assigned to object (property, list element, etc.) to which data is copied. More...
static void | CopyListToObject< DtoType, ObjectType > (DtoType[] tabDto, ref List< ObjectType > listObj)
| Copies array of DTOs (Data Transfer Objects) to a list of appropriate objects. More...
static DtoType[] | CopyListFromObjectReturned< DtoType, ObjectType > (List< ObjectType > tabObj, DtoType[] tabDto)
| Replacement for CopyArrayFromObject for cases where object can not be passed by reference. The returned object must be assigned to object (property, list element, etc.) to which data is copied. More...
static void | CopyListFromObject< DtoType, ObjectType > (List< ObjectType > tabObj, ref DtoType[] tabDto)
| Copies array of objects to a list of DTOs. More...

## Detailed Description

Transfer Object (DTO) for neural network training set.

$A Igor Jul10; Tako78 Jun12;

## Member Function Documentation

override NeuralTrainingParameters IG.Num.NeuralTrainingParametersDto.CreateObject | ( |  | ) |
| inline

Creates and returns a new object of the corresponding type.

override void IG.Num.NeuralTrainingParametersDto.CopyFromPlain | ( | NeuralTrainingParameters | trainingParameters | ) |
| inline protected

Copies the specified training parameters to the current DTO.

Parameters

  trainingParameters | Object that is copied to the current DTO.

References IG.Num.NeuralTrainingParameters.EpochErrorsAbs, IG.Num.NeuralTrainingParameters.EpochErrorsRms, IG.Num.NeuralTrainingParameters.EpochNumbers, IG.Num.NeuralTrainingParameters.EpochsInBundle, IG.Num.NeuralTrainingParameters.ErrorsTrainingMax, IG.Num.NeuralTrainingParameters.ErrorsTrainingMaxList, IG.Num.NeuralTrainingParameters.ErrorsTrainingMeanAbs, IG.Num.NeuralTrainingParameters.ErrorsTrainingRms, IG.Num.NeuralTrainingParameters.ErrorsTrainingRmsList, IG.Num.NeuralTrainingParameters.ErrorsVerificationMax, IG.Num.NeuralTrainingParameters.ErrorsVerificationMaxList, IG.Num.NeuralTrainingParameters.ErrorsVerificationMeanAbs, IG.Num.NeuralTrainingParameters.ErrorsVerificationRms, IG.Num.NeuralTrainingParameters.ErrorsVerificationRmsList, IG.Num.NeuralTrainingParameters.InputBoundSafetyFactor, IG.Num.NeuralTrainingParameters.InputLength, IG.Num.NeuralTrainingParameters.InputRange, IG.Num.NeuralTrainingParameters.IsNetworkTrained, IG.Num.NeuralTrainingParameters.LearningRate, IG.Num.NeuralTrainingParameters.MaxEpochs, IG.Num.NeuralTrainingParameters.Momentum, IG.Num.NeuralTrainingParameters.NumEpochs, IG.Num.NeuralTrainingParameters.NumHiddenLayers, IG.Num.NeuralTrainingParameters.NumHidenNeurons, IG.Num.NeuralTrainingParameters.OutputBoundSafetyFactor, IG.Num.NeuralTrainingParameters.OutputLength, IG.Num.NeuralTrainingParameters.OutputRange, IG.Num.NeuralTrainingParameters.SigmoidAlphaValue, IG.Num.NeuralTrainingParameters.ToleranceMax, IG.Num.NeuralTrainingParameters.ToleranceMaxRelativeToRange, IG.Num.NeuralTrainingParameters.ToleranceMaxRelativeToRangeScalar, IG.Num.NeuralTrainingParameters.ToleranceRms, IG.Num.NeuralTrainingParameters.ToleranceRmsRelativeToRange, IG.Num.NeuralTrainingParameters.ToleranceRmsRelativeToRangeScalar, IG.Num.NeuralTrainingParameters.TrainingCpuTime, and IG.Num.NeuralTrainingParameters.TrainingTime.

override void IG.Num.NeuralTrainingParametersDto.CopyToPlain | ( | ref NeuralTrainingParameters | trainingParameters | ) |
| inline protected

Copies contents of the current DTO to the specified training parameters object.

Parameters

  trainingParameters | Object that the current DTO content is copied to.

## Member Data Documentation

double IG.Num.NeuralTrainingParametersDto.LearningRate

Learning rate.

double IG.Num.NeuralTrainingParametersDto.Momentum

Momentum. Specifies how much changes of weight in the previous iterations affect changes in the current iterations.

double IG.Num.NeuralTrainingParametersDto.SigmoidAlphaValue

Sigmoid alpha value (used in networks with sigmoid activation functions).

int IG.Num.NeuralTrainingParametersDto.InputLength

Gets or sets the number of input neurons.

int IG.Num.NeuralTrainingParametersDto.OutputLength

Gets or sets the number of output neurons.

double IG.Num.NeuralTrainingParametersDto.InputBoundSafetyFactor

double IG.Num.NeuralTrainingParametersDto.OutputBoundSafetyFactor

int IG.Num.NeuralTrainingParametersDto.MaxEpochs

Maximal number of epochs performed in the training procedure.

$A Tako78 Jul12;

int IG.Num.NeuralTrainingParametersDto.EpochsInBundle

Number of epochs in bundle (i.e. number of epochs performed at once, without any checks or output operations between).

This parameter does not affect the training procedure in terms of results.

$A Tako78 Jul12;

VectorDtoBase IG.Num.NeuralTrainingParametersDto.InputRange

Range from actual inputs.

$A Tako78 Octl12;

VectorDtoBase IG.Num.NeuralTrainingParametersDto.OutputRange

Range from actual outputs.

$A Tako78 Octl12;

VectorDtoBase IG.Num.NeuralTrainingParametersDto.ToleranceRms

Tolerance over RMS error of outputs over training points. Training will continue until error becomes below tolerance or until maximal number of epochs is reached. If less or equal than 0 then this tolerance is not taken into account.

$A Tako78 Jul12; Igor Jul12;

VectorDtoBase IG.Num.NeuralTrainingParametersDto.ToleranceRmsRelativeToRange

Relative tolerances on RMS errors of outputs over training points, relative to the correspoinding ranges of output data.

See also
  NeuralApproximatorBase.ToleranceRmsRelativeToRange

double IG.Num.NeuralTrainingParametersDto.ToleranceRmsRelativeToRangeScalar = NeuralTrainingParameters.DefaultToleranceRmsRelativeToRangeScalar

Scalar through which all components of the Relative tolerances on RMS errors of outputs can be set to the same value.

See also
  NeuralApproximatorBase.ToleranceRmsRelativeToRangeScalar

VectorDtoBase IG.Num.NeuralTrainingParametersDto.ToleranceMax

Tolerance on maximal error of outputs over training points. Training will continue until error becomes below tolerance or until maximal number of epochs is reached. If less or equal than 0 then this tolerance is not taken into account.

$A Tako78 Jul12;

VectorDtoBase IG.Num.NeuralTrainingParametersDto.ToleranceMaxRelativeToRange

Relative tolerances on max. abs. errors of outputs over training points, relative to the correspoinding ranges of output data.

See also
  NeuralApproximatorBase.ToleranceMaxRelativeToRange

double IG.Num.NeuralTrainingParametersDto.ToleranceMaxRelativeToRangeScalar = NeuralTrainingParameters.DefaultToleranceMaxRelativeToRangeScalar

Scalar through which all components of the Relative tolerances on max. abs. errors of outputs can be set to the same value.

See also
  NeuralApproximatorBase.ToleranceMaxRelativeToRangeScalar

int IG.Num.NeuralTrainingParametersDto.NumHiddenLayers

Number of Hideden layers.

$A Tako78 Jul12;

int [] IG.Num.NeuralTrainingParametersDto.NumHidenNeurons

Numbers of neurons in each hidden layer.

$A Tako78 Jul12;

bool IG.Num.NeuralTrainingParametersDto.IsNetworkTrained

Whether the network is trained (and results exist).

$A Tako78 Jul12;

VectorDtoBase IG.Num.NeuralTrainingParametersDto.ErrorsTrainingRms

RMS errors calculated on training data.

$A Tako78 Jul12;

VectorDtoBase [] IG.Num.NeuralTrainingParametersDto.ErrorsTrainingRmsTable

Convergence Table of RMS errors calculated on training data.

$A Tako78 Aug12;

VectorDtoBase IG.Num.NeuralTrainingParametersDto.ErrorsTrainingMax

Maximal errors calculated on training data.

$A Tako78 Jul12;

VectorDtoBase [] IG.Num.NeuralTrainingParametersDto.ErrorsTrainingMaxTable

Convergence Table of Maximal errors calculated on training data.

$A Tako78 Aug12;

VectorDtoBase IG.Num.NeuralTrainingParametersDto.ErrorsTrainingMeanAbs

Mean absolute errors calculated on training data.

$A Tako78 Jul12;

VectorDtoBase IG.Num.NeuralTrainingParametersDto.ErrorsVerificationRms

RMS errors calculated on verification data.

$A Tako78 Jul12;

VectorDtoBase [] IG.Num.NeuralTrainingParametersDto.ErrorsVerificationRmsTable

Convergence Table of RMS errors calculated on verification data.

$A Tako78 Aug12;

VectorDtoBase IG.Num.NeuralTrainingParametersDto.ErrorsVerificationMax

Maximal errors calculated on verification data.

$A Tako78 Jul12;

VectorDtoBase [] IG.Num.NeuralTrainingParametersDto.ErrorsVerificationMaxTable

Convergence Table of Maximal errors calculated on verification data.

$A Tako78 Aug12;

VectorDtoBase IG.Num.NeuralTrainingParametersDto.ErrorsVerificationMeanAbs

Maximal errors calculated on training data.

$A Tako78 Jul12;

List<VectorDtoBase> IG.Num.NeuralTrainingParametersDto.ErrorsRmsList

int IG.Num.NeuralTrainingParametersDto.NumEpochs

Number of epochs actually spent at training.

$A Tako78 Jul12;

double IG.Num.NeuralTrainingParametersDto.TrainingTime

Time spent for training.

$A Tako78 Jul12;;

double IG.Num.NeuralTrainingParametersDto.TrainingCpuTime

CPU time spent for training.

$A Tako78 Jul12;

int [] IG.Num.NeuralTrainingParametersDto.EpochNumbers

List of epoch numbers at which convergence data was sampled.

double [] IG.Num.NeuralTrainingParametersDto.EpochErrorsRms

List of sampled RMS errors corresponding to epoch numbers from EpochNumbers.

double [] IG.Num.NeuralTrainingParametersDto.EpochErrorsAbs

List of sampled absolute errors corresponding to epoch numbers from EpochNumbers.

The documentation for this class was generated from the following file:

- igbase/numeric/approximation/neural/SerializationDtoNeural.cs